SHADER version 1
@OpenGL2.Vertex
uniform mat4 projectionmatrix;
uniform mat4 drawmatrix;
uniform vec2 offset;
uniform vec2 position[4];
uniform vec2 texcoords[4];

attribute vec3 vertex_position;

varying vec2 ex_texcoords0;

void main(void)
{
	int i = int(vertex_position.x);//gl_VertexID was implemented in GLSL 1.30, not available in 1.20.
	gl_Position = projectionmatrix * (drawmatrix * vec4(position[i], 1.0, 1.0));
	ex_texcoords0 = texcoords[i];
}
@OpenGL2.Fragment
uniform sampler2D texture0;
uniform vec2 buffersize;
uniform vec4 drawcolor;

varying vec2 ex_texcoords0;

void main(void)
{
	gl_FragColor = texture2D(texture0,ex_texcoords0) * drawcolor;
}
@OpenGLES2.Vertex
uniform mediump mat4 projectionmatrix;
uniform mediump mat4 drawmatrix;
uniform mediump vec2 offset;

attribute mediump vec3 vertex_position;
attribute mediump vec2 vertex_texcoords0;

varying mediump vec2 ex_texcoords0;

void main(void)
{
	gl_Position = projectionmatrix * (drawmatrix * vec4(vertex_position, 1.0) + vec4(offset,0,0));
	ex_texcoords0 = vertex_texcoords0;
}
@OpenGLES2.Fragment
uniform sampler2D texture0;
uniform mediump vec2 buffersize;
uniform mediump vec4 drawcolor;

varying mediump vec2 ex_texcoords0;

void main(void)
{
	gl_FragData[0] = texture2D(texture0,ex_texcoords0) * drawcolor;
}
@OpenGL4.Vertex
#version 400

uniform mat4 projectionmatrix;
uniform mat4 drawmatrix;
uniform vec2 offset;
uniform vec2 position[4];

in vec3 vertex_position;

void main(void)
{
	gl_Position = projectionmatrix * (drawmatrix * vec4(position[gl_VertexID]+offset, 0.0, 1.0));
}
@OpenGL4.Fragment
#version 400

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform bool isbackbuffer;
uniform sampler2D texture9;
uniform vec2 buffersize;
uniform float currenttime;

out vec4 fragData0;

const vec3 lumask = vec3(0.2125, 0.7154, 0.0721);
const float bright_add = 0.25;


void main(void)
{

vec2 icoord = vec2(gl_FragCoord.xy/buffersize);
if (isbackbuffer) icoord.y = 1.0 - icoord.y;
	
const ivec2 add = ivec2(1,0);
vec3 color = 0.25*(
textureOffset(texture1, icoord, +add.xy)+
textureOffset(texture1, icoord, -add.xy)+
textureOffset(texture1, icoord, +add.yx)+
textureOffset(texture1, icoord, -add.yx)
).xyz;

float bright = log(dot(color, lumask) + bright_add);
color += 0.2*sin(-10.0*color/(color+vec3(2.0)));

/*vec2 texelSize=vec2(2*buffersize);
    vec4 accum = vec4(0.0, 0.0, 0.0, 0.0);
    vec4 LUMINENCE_FACTOR = vec4(0.27, 0.67, 0.06, 0.0);

    // Get colour from source
    accum += texture2D(texture1, icoord + texelSize * vec2(-0.5, -0.5));
    accum += texture2D(texture1, icoord + texelSize * vec2(-0.5, 0.5));
    accum += texture2D(texture1, icoord + texelSize * vec2(0.5, 0.5));
    accum += texture2D(texture1, icoord + texelSize * vec2(0.5, -0.5));
    
// Adjust the accumulated amount by lum factor
float lum = dot(accum, LUMINENCE_FACTOR);
// take average of 4 samples
lum *= 0.25;
//fragData0 = vec4(lum, lum, lum, 1.0);*/
 
fragData0 = vec4(color, bright);
//fragData0 *= vec4(lum);
}
